PKIXRevocationChecker.Option (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.security.cert, class: PKIXRevocationChecker, enum: Option
Keywords: java.security.cert.PKIXRevocationChecker.Option class

# Enum Class PKIXRevocationChecker.Option

java.lang.Object
java.lang.Enum<PKIXRevocationChecker.Option>
java.security.cert.PKIXRevocationChecker.Option

All Implemented Interfaces:
  `Serializable, Comparable<PKIXRevocationChecker.Option>, Constable`

Enclosing class:
  `PKIXRevocationChecker`

public static enum PKIXRevocationChecker.Option extends Enum<PKIXRevocationChecker.Option>
Various revocation options that can be specified for the revocation checking mechanism.

Since:
  1.8

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Enum

  `Enum.EnumDesc<E>`
  Modifier and Type
  Class
  Description
  `static final class`
  `Enum.EnumDesc<E extends Enum<E>>`
  A nominal descriptor for an `enum` constant.

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `NO_FALLBACK`
  Disable the fallback mechanism.
  `ONLY_END_ENTITY`
  Only check the revocation status of end-entity certificates.
  `PREFER_CRLS`
  Prefer CRLs to OSCP.
  `SOFT_FAIL`
  Allow revocation check to succeed if the revocation status cannot be determined for one of the following reasons: The CRL or OCSP response cannot be obtained because of a network error.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static PKIXRevocationChecker.Option`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static PKIXRevocationChecker.Option[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`
  Modifier and Type
  Method
  Description
  `protected final Object`
  `clone()`
  Throws CloneNotSupportedException.
  `final int`
  `compareTo(PKIXRevocationChecker.Option o)`
  Compares this enum with the specified object for order.
  `final Optional<Enum.EnumDesc<PKIXRevocationChecker.Option>>`
  `describeConstable()`
  Returns an enum descriptor `EnumDesc` for this instance, if one can be constructed, or an empty `Optional` if one cannot be.
  `final boolean`
  `equals(Object other)`
  Returns true if the specified object is equal to this enum constant.
  `protected final void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization has been deprecated for removal.
  `final Class<PKIXRevocationChecker.Option>`
  `getDeclaringClass()`
  Returns the Class object corresponding to this enum constant's enum type.
  `final int`
  `hashCode()`
  Returns a hash code for this enum constant.
  `final String`
  `name()`
  Returns the name of this enum constant, exactly as declared in its enum declaration.
  `final int`
  `ordinal()`
  Returns the ordinal of this enumeration constant (its position in its enum declaration, where the initial constant is assigned an ordinal of zero).
  `String`
  `toString()`
  Returns the name of this enum constant, as contained in the declaration.
  `static <T extends Enum<T>>
  T`
  `valueOf(Class<T> enumClass, String name)`
  Returns the enum constant of the specified enum class with the specified name.

  ### Methods declared in class Object

  `getClass, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Enum Constant Details

  - ### ONLY_END_ENTITY

    public static final PKIXRevocationChecker.Option ONLY_END_ENTITY
    Only check the revocation status of end-entity certificates.

  - ### PREFER_CRLS

    public static final PKIXRevocationChecker.Option PREFER_CRLS
    Prefer CRLs to OSCP. The default behavior is to prefer OCSP. Each PKIX implementation should document further details of their specific preference rules and fallback policies.

  - ### NO_FALLBACK

    public static final PKIXRevocationChecker.Option NO_FALLBACK
    Disable the fallback mechanism.

  - ### SOFT_FAIL

    public static final PKIXRevocationChecker.Option SOFT_FAIL
    Allow revocation check to succeed if the revocation status cannot be determined for one of the following reasons:
    - The CRL or OCSP response cannot be obtained because of a network error.
    - The OCSP responder returns one of the following errors specified in section 2.3 of RFC 2560: internalError or tryLater.
    Note that these conditions apply to both OCSP and CRLs, and unless the `NO_FALLBACK` option is set, the revocation check is allowed to succeed only if both mechanisms fail under one of the conditions as stated above. Exceptions that cause the network errors are ignored but can be later retrieved by calling the `getSoftFailExceptions` method.

- ## Method Details

  - ### values

    public static PKIXRevocationChecker.Option[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static PKIXRevocationChecker.Option valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null